// Hova tegye a spriteok adatait, ezek fixen rgztve vannak a memria egy adott terletn s mindig 256-al oszthat helyen!
#define SPRITE_RAM 0xC000
// Jtkmotor importlsa
#include <../JatekMotor/jm.c>

// Sprite kpe
unsigned char player[24]={
// player.0 sprite 
0b00011000,
0b00111100,
0b01100110,
0b01100110,
0b11111111,
0b11111111,
0b11011011,
0b10000001,

// player.1 sprite 
0b00011000,
0b00111100,
0b00110100,
0b01110110,
0b01111110,
0b01111110,
0b01011010,
0b01000010,

// player.2 sprite 
0b00011000,
0b00111100,
0b00101100,
0b01101110,
0b01111110,
0b01111110,
0b01011010,
0b01000010,
};


#include <../images/startscreen.c>
#include <../images/topbanner.c>
#include <../images/boss.c>
#include <../images/enemy1.c>


// Zene 
unsigned char musicdatas[96]={
note_D4,note_F4,note_A4,note_D3,
note_D4,note_F4,note_A4,note_D3,
note_D4,note_E4,note_A4,note_D3,
note_D4,note_G4,note_A4,note_D3,
note_D4,note_F4,note_A4,note_D3,
note_D4,note_G4,note_A4,note_D3,
note_D4,note_E4,note_A4,note_D3,
note_D4,note_F4,note_A4,note_D3,

note_D4,note_F4,note_Ais4,note_Ais2,
note_D4,note_F4,note_Ais4,note_Ais2,
note_D4,note_E4,note_Ais4,note_Ais2,
note_D4,note_G4,note_Ais4,note_Ais2,
note_D4,note_F4,note_Ais4,note_Ais2,
note_D4,note_G4,note_Ais4,note_Ais2,
note_D4,note_E4,note_Ais4,note_Ais2,
note_D4,note_F4,note_Ais4,note_Ais2,

note_C4,note_E4,note_G4,note_C3,
note_C4,note_E4,note_G4,note_C3,
note_C4,note_D4,note_G4,note_C3,
note_C4,note_F4,note_G4,note_C3,
note_C4,note_E4,note_G4,note_C3,
note_C4,note_D4,note_G4,note_C3,
note_C4,note_F4,note_G4,note_C3,
note_C4,note_E4,note_G4,note_C3,
};


void nyitolap() {
	drawimage(startscreen,VRAMx,32,96);
	unsigned char musictime=0;
	unsigned char musici=0;
	do {
		if (musictime==0) {				
			sound(musicdatas[musici],40); // Hang lejtszsa (hangmagassg byte, hang hossz byte)
			musici++;
			if (musici>95) { musici=0; }			 
			musictime=80;
		} else {
			musictime--;
		}
		waitforsync();
		inkey();
	} while ((wasdspaceq & KEY_SPACE)!=KEY_SPACE);
	clearscreen();

}

void main() {
	// Lerli a kpernyt, belltja a sprite-okat stb...
	jminit(); 
	nyitolap();

	drawimage(topbanner,VRAMx,32,16);
	
	// 0. sprite, x,y,bitmapaddr,frame index,szlessg pixelben (8 vagy 16),magassg pixelben
	setSprite(0,128,170,&player,0,8,8);
	sprite8_visible[0]=1;
	
	setSprite(1,128,70,&enemy1,0,8,8);
	sprite8_visible[1]=1;

	signed char dx=0;
	signed char dy=0;	

	while (1) {
		dx=0;dy=0; // irnyok nullzsa
		inkey(); // billentyzet beolvassa
		if ((wasdspaceq & KEY_A)==KEY_A) { dx=-1; } // A balra
		if ((wasdspaceq & KEY_D)==KEY_D) { dx=1;  } // D jobbra
		if ((wasdspaceq & KEY_W)==KEY_W) { dy=-1; } // W fel
		if ((wasdspaceq & KEY_S)==KEY_S) { dy=1;  } // S le
		sprite8_frame[0]=0; // alapbl 0. frame vagyis felfel
		if (dx==1) { sprite8_frame[0]=1; } // Ha dx=1 akkor a jobbra fordul sprite ami az 1. frame
		if (dx==-1) { sprite8_frame[0]=2; } // Ha dx=-1 akkor a balra fordul sprite ami az 2. frame
		
		sprite8_x[0]+=dx; // sprite x kordintjnak vltoztatsa
		sprite8_y[0]+=dy; // sprite y kordintjnak vltoztatsa
		
		//////  Sprite-ok adatainak kiszmolsa, szinkron megvrsa, sprite-ok trlse s jrarajzolsa ////////
		calcsprites8();	 // Sprite adatok szmolsa (cmek, eltols stb...)
		waitforsync();   // Kpszinkron megvrsa
		clearsprites8(); // sszes sprite tlse
		drawsprite8(0);	 // 0. sprite kirajzolsa
		drawsprite8(1);	 // 1. sprite kirajzolsa
		

	} // Jtk ciklus vge
		
	
} // MAIN vge